//=========================================================================
//
//	Test program
//
//=========================================================================

#include "p18cxxx.h"
#include "sd.h"

// PIC18F2550
        #pragma config PLLDIV   = 3         // (12 MHz crystal)
        #pragma config CPUDIV   = OSC1_PLL2   
        #pragma config USBDIV   = 2         // Clock source from 96MHz PLL/2
        #pragma config FOSC     = HSPLL_HS
        #pragma config FCMEN    = OFF
        #pragma config IESO     = OFF
        #pragma config PWRT     = OFF
        #pragma config BOR      = OFF
        #pragma config BORV     = 3
        #pragma config VREGEN   = ON      //USB Voltage Regulator
        #pragma config WDT      = OFF
        #pragma config WDTPS    = 32768
        #pragma config MCLRE    = OFF
        #pragma config LPT1OSC  = OFF
        #pragma config PBADEN   = OFF
//      #pragma config CCP2MX   = ON
        #pragma config STVREN   = ON
        #pragma config LVP      = OFF
//      #pragma config ICPRT    = OFF       // Dedicated In-Circuit Debug/Programming
        #pragma config XINST    = OFF       // Extended Instruction Set
        #pragma config CP0      = OFF
        #pragma config CP1      = OFF
//      #pragma config CP2      = OFF
//      #pragma config CP3      = OFF
        #pragma config CPB      = OFF
//      #pragma config CPD      = OFF
        #pragma config WRT0     = OFF
        #pragma config WRT1     = OFF
//      #pragma config WRT2     = OFF
//      #pragma config WRT3     = OFF
        #pragma config WRTB     = OFF       // Boot Block Write Protection
        #pragma config WRTC     = OFF
//      #pragma config WRTD     = OFF
        #pragma config EBTR0    = OFF
        #pragma config EBTR1    = OFF
//      #pragma config EBTR2    = OFF
//      #pragma config EBTR3    = OFF
        #pragma config EBTRB    = OFF

//
// Private code
//
void main(void){
	int i;
	int fd;
	char fname[] = "test.txt";
	char buf[16] = "0123456789\r\n";

	PORTA = 0x00;
	TRISAbits.TRISA0 = 0;
	TRISAbits.TRISA1 = 0;
	TRISAbits.TRISA2 = 0;
	TRISAbits.TRISA3 = 0;

	// Mount
	if (sd_mount(0) < 0) {
		for(;;);
	}
	PORTAbits.RA0 = 1;

	SD_SET_DATE(2010,1,1);
	SD_SET_TIME(12,34,56);

	// Open
	if ((fd = sd_open(fname, SD_O_CREAT|SD_O_APPEND, 0)) < 0) {
		for(;;);
	}
	PORTAbits.RA1 = 1;

	// Write
	for(i = 0; i < 100; i++) {
		if (sd_write(fd, buf, 12) <= 0) {
			for(;;);
		}
	}
	PORTAbits.RA2 = 1;

	// Close
	if (sd_close(fd) < 0) {
		for(;;);
	}

	// unmount
	if (sd_unmount() < 0) {
		for(;;);
	}
	PORTAbits.RA3 = 1;

	for(;;);
}
